From 7566e6f82f86b96580ac72939ebfd809f506df42 Mon Sep 17 00:00:00 2001
From: Nikos Mavrogiannopoulos <nmav@redhat.com>
Date: Fri, 20 Jun 2014 14:37:13 +0200
Subject: [PATCH] Turn RSA blinding off in openssl RSA benchmark.

That allows direct comparison with hogweed's RSA results.
---
 examples/hogweed-benchmark.c | 1 +
 1 file changed, 1 insertion(+)

diff --git a/examples/hogweed-benchmark.c b/examples/hogweed-benchmark.c
index 05372ab..311fa2d 100644
--- a/examples/hogweed-benchmark.c
+++ b/examples/hogweed-benchmark.c
@@ -521,6 +521,7 @@ bench_openssl_rsa_init (unsigned size)
   ctx->ref = xalloc (RSA_size (ctx->key));
   ctx->signature = xalloc (RSA_size (ctx->key));
   ctx->digest = hash_string (&nettle_sha1, 3, "foo");
+  RSA_blinding_off(ctx->key);
 
   if (! RSA_sign (NID_sha1, ctx->digest, SHA1_DIGEST_SIZE,
 		  ctx->ref, &ctx->siglen, ctx->key))
-- 
1.9.3